CREATE OR REPLACE PROCEDURE REPLICA_PEDALTCARD
(
    P_NRPEDALTCARD NUMBER,
    P_CDOPERADOR VARCHAR2
)
AS
   V_NRPEDALTCARD_NOVO NUMBER;
   V_CDPEDALTCARD_NOVO VARCHAR2(10);
   V_CDFILIAL VARCHAR2(4);
   V_CDSERVFILI VARCHAR2(5);
   V_DTMESCARD DATE;
   V_IDSOLEXTRA VARCHAR2(1);
   V_DSJUSTICATIVA VARCHAR2(1000);
   V_DSRESPOSTA VARCHAR2(1000);
BEGIN
   V_NRPEDALTCARD_NOVO := TO_NUMBER(RETORNA_NOVO_CODIGO('PEDALTCARD', 1));
   V_CDPEDALTCARD_NOVO := LPAD(TO_CHAR(V_NRPEDALTCARD_NOVO), 10, '0');
   
   SELECT CDFILIAL, CDSERVFILI, DTMESCARD, IDSOLEXTRA,
          DSJUSTICATIVA, DSRESPOSTA
     INTO V_CDFILIAL, V_CDSERVFILI, V_DTMESCARD, V_IDSOLEXTRA,
          V_DSJUSTICATIVA, V_DSRESPOSTA
   FROM PEDALTCARD
   WHERE NRPEDALTCARD = P_NRPEDALTCARD;

   --Insere o novo pedido com base no primeiro
   INSERT INTO PEDALTCARD
   (
      NRPEDALTCARD, CDPEDALTCARD, DTPEDALTCARD,
      CDOPERADOR, CDFILIAL, CDSERVFILI,
      DTMESCARD, IDSITUACAO, IDSOLEXTRA,
      DTAPROVREPR, CDOPERAPROVREPR, DTAPROVREPRGO, 
      CDOPERAPROVREPRGO, DSJUSTICATIVA, DSRESPOSTA, 
      IDPEDIDOREFEITO,
      DTINCLUSAO, DTULTATU,
      CDOPERINCLUSAO, CDOPERULTATU
   )
   VALUES
   (
      V_NRPEDALTCARD_NOVO, V_CDPEDALTCARD_NOVO, SYSDATE,
      P_CDOPERADOR, V_CDFILIAL, V_CDSERVFILI,
      V_DTMESCARD, 'E', V_IDSOLEXTRA,
      NULL, NULL, NULL, 
      NULL, V_DSJUSTICATIVA, V_DSRESPOSTA, 
      'S',
      SYSDATE, SYSDATE,
      P_CDOPERADOR, P_CDOPERADOR
   );

   -- Insere as alterações lançadas nos comensais do dia e turnos
   INSERT INTO PEDALTCARDDIA
   (
      NRPEDALTCARDDIA, NRPEDALTCARD, CDFILIAL,
      NRCARDAPIO, DTCARDAPIO, QTCLIESTICAR,
      QTFUNESTICAR, QTDOAESTICAR, QTESTITURNO1,
      QTESTITURNO2, QTESTITURNO3, QTESTITURNO4, 
      DTINCLUSAO, DTULTATU,
      CDOPERINCLUSAO, CDOPERULTATU
   )
   SELECT RETORNA_NOVO_CODIGO('PEDALTCARDDIA', 1), V_NRPEDALTCARD_NOVO, V_CDFILIAL,
         NRCARDAPIO, DTCARDAPIO, QTCLIESTICAR,
         QTFUNESTICAR, QTDOAESTICAR, QTESTITURNO1,
         QTESTITURNO2, QTESTITURNO3, QTESTITURNO4,
         SYSDATE, SYSDATE,
         P_CDOPERADOR, P_CDOPERADOR
   FROM PEDALTCARDDIA
   WHERE NRPEDALTCARD = P_NRPEDALTCARD;

   -- Insere as alterações lançadas nos comensais por ponto de entrega
   INSERT INTO PEDALTCARDCLI
   (
      NRPEDALTCARDCLI, NRPEDALTCARD, CDFILIAL,
      NRCARDAPIO, DTCARDAPIO, CDCLIENTE,
      CDDESTFILI, QTCOMESTICLI,
      DTINCLUSAO, DTULTATU,
      CDOPERINCLUSAO, CDOPERULTATU
   )
   SELECT RETORNA_NOVO_CODIGO('PEDALTCARDCLI', 1), V_NRPEDALTCARD_NOVO, V_CDFILIAL,
      NRCARDAPIO, DTCARDAPIO, CDCLIENTE,
      CDDESTFILI, QTCOMESTICLI,
      SYSDATE, SYSDATE,
      P_CDOPERADOR, P_CDOPERADOR
   FROM PEDALTCARDCLI
   WHERE NRPEDALTCARD = P_NRPEDALTCARD;
   
   -- Insere as alterações lançadas nos pratos e adesão
   INSERT INTO PEDALTCARDCOMP
   (
      NRPEDALTCARDCOMP, NRPEDALTCARD, CDFILIAL,
      NRCARDAPIO, DTCARDAPIO, NRSEQPRATCAR,
      CDFILAUXPRAT, CDPRATO, VRPECONSCARD,
      DTINCLUSAO, DTULTATU,
      CDOPERINCLUSAO, CDOPERULTATU
   )
   SELECT
      RETORNA_NOVO_CODIGO('PEDALTCARDCOMP', 1), V_NRPEDALTCARD_NOVO, V_CDFILIAL,
      NRCARDAPIO, DTCARDAPIO, NRSEQPRATCAR,
      CDFILAUXPRAT, CDPRATO, VRPECONSCARD,
      DTINCLUSAO, DTULTATU,
      CDOPERINCLUSAO, CDOPERULTATU
   FROM PEDALTCARDCOMP
   WHERE NRPEDALTCARD = P_NRPEDALTCARD;
END;
/