CREATE OR REPLACE PROCEDURE PERCAPITA_PEDALTCARD
(
    P_NRPEDALTCARD NUMBER,
    P_CDTIPOCUSTO VARCHAR2,
    P_DTREFERENCIA DATE,
    P_CDOPERADOR VARCHAR2,
    P_PERCAPITA_OLD OUT FLOAT,
    P_PERCAPITA_NEW OUT FLOAT
)
AS
    V_CDFILIAL VARCHAR2(4);
    V_CDSERVFILI VARCHAR2(5);
    V_DTMESCARD DATE;
    V_COMEN_DIA FLOAT;
    V_COMEN_DIA_ALT FLOAT;
    V_COMENSAIS FLOAT := 0;
    V_COMENSAIS_ALT FLOAT := 0;
    V_IDCOMCUSPERC VARCHAR2(1);
    V_CUSTO_DIA FLOAT := 0;
    V_CUSTO_DIA_ALT FLOAT := 0;
    V_CUSTO FLOAT := 0;
    V_CUSTO_ALT FLOAT := 0;
    V_CUSTO_DIA_INC FLOAT := 0;
    V_NRCONSPLAN VARCHAR2(10);
    V_CUSTO_CONSUMO FLOAT := 0;
BEGIN
    -- Busca os dados do pedido
    BEGIN
        SELECT CDFILIAL, CDSERVFILI, DTMESCARD
        INTO V_CDFILIAL, V_CDSERVFILI, V_DTMESCARD
        FROM PEDALTCARD
        WHERE NRPEDALTCARD = P_NRPEDALTCARD;
    EXCEPTION
        WHEN OTHERS THEN
            V_CDFILIAL := NULL;
            V_CDSERVFILI := NULL;
            V_DTMESCARD := NULL;
    END;
    SELECT 
        MAX(IDCOMCUSPERC)
    INTO V_IDCOMCUSPERC
    FROM PARAMFILIAL
    WHERE CDFILIAL = V_CDFILIAL;
    FOR C_CARD IN
    (
        SELECT CD.CDFILIAL, CD.CDSERVFILI, CD.NRCARDAPIO, CD.DTCARDAPIO,
            CD.QTCLIESTICAR, CD.QTCOMESTICAR,
            NVL(P.QTCLIESTICAR, CD.QTCLIESTICAR) AS QTCLIESTICAR_ALT,
            NVL(P.QTCLIESTICAR, CD.QTCLIESTICAR) + NVL(P.QTFUNESTICAR, CD.QTFUNESTICAR) + NVL(P.QTDOAESTICAR, CD.QTDOAESTICAR) AS QTCOMESTICAR_ALT
        FROM CARDADIA CD
            LEFT JOIN PEDALTCARDDIA P ON P.NRPEDALTCARD = P_NRPEDALTCARD AND P.DTCARDAPIO = CD.DTCARDAPIO
        WHERE CD.CDFILIAL = V_CDFILIAL
        AND CD.CDSERVFILI = V_CDSERVFILI
        AND CD.DTCARDAPIO BETWEEN V_DTMESCARD AND LAST_DAY(V_DTMESCARD)   
    ) LOOP
        IF V_IDCOMCUSPERC = 'C' THEN
            V_COMEN_DIA := NVL(C_CARD.QTCLIESTICAR, 0);
            V_COMEN_DIA_ALT := NVL(C_CARD.QTCLIESTICAR_ALT, 0);
        ELSE 
            V_COMEN_DIA := NVL(C_CARD.QTCOMESTICAR, 0);
            V_COMEN_DIA_ALT := NVL(C_CARD.QTCOMESTICAR_ALT, 0);
        END IF;
        V_COMENSAIS := V_COMENSAIS + V_COMEN_DIA;
        V_COMENSAIS_ALT := V_COMENSAIS_ALT + V_COMEN_DIA_ALT;
        SELECT 
            SUM(
                NVL(C.VRPECONSCARD, 0)/100 * 
                V_COMEN_DIA *
                CUSTO_PRATO(C_CARD.CDFILIAL, C_CARD.CDFILIAL, P_CDTIPOCUSTO,
                P_DTREFERENCIA, C.CDFILAUXPRAT,C.CDPRATO,
                C_CARD.CDSERVFILI)
            ),
            SUM(
                NVL(NVL(P.VRPECONSCARD, C.VRPECONSCARD), 0)/100 * 
                V_COMEN_DIA_ALT *
                CUSTO_PRATO(C_CARD.CDFILIAL, C_CARD.CDFILIAL, P_CDTIPOCUSTO,
                P_DTREFERENCIA, NVL(P.CDFILAUXPRAT, C.CDFILAUXPRAT), NVL(P.CDPRATO, C.CDPRATO),
                C_CARD.CDSERVFILI)
            )
            INTO V_CUSTO_DIA, V_CUSTO_DIA_ALT
        FROM COMPCARD C
            LEFT JOIN PEDALTCARDCOMP P ON P.NRPEDALTCARD = P_NRPEDALTCARD AND P.DTCARDAPIO = C_CARD.DTCARDAPIO AND P.NRSEQPRATCAR = C.NRSEQPRATCAR
        WHERE C.CDFILIAL = C_CARD.CDFILIAL
        AND C.NRCARDAPIO = C_CARD.NRCARDAPIO;
        -- Busca o custo dos pratos adicionados
        SELECT
            SUM(
                NVL(P.VRPECONSCARD, 0)/100 * 
                V_COMEN_DIA_ALT *
                CUSTO_PRATO(C_CARD.CDFILIAL, C_CARD.CDFILIAL, P_CDTIPOCUSTO,
                P_DTREFERENCIA, P.CDFILAUXPRAT,P.CDPRATO,
                C_CARD.CDSERVFILI)
            )
        INTO V_CUSTO_DIA_INC
        FROM PEDALTCARDCOMP P 
        WHERE P.NRPEDALTCARD = P_NRPEDALTCARD
        AND P.DTCARDAPIO = C_CARD.DTCARDAPIO;

        V_CUSTO := V_CUSTO + NVL(V_CUSTO_DIA, 0);
        V_CUSTO_ALT := V_CUSTO_ALT + NVL(V_CUSTO_DIA_ALT, 0) + NVL(V_CUSTO_DIA_INC, 0);
    END LOOP;
    -- Popula a CONSPLAN para obter o consumo per capita e fixo e som-lo ao custo total
    V_NRCONSPLAN := RETORNA_NOVO_CODIGO('CONSPLAN' || V_CDFILIAL, 1, 10);
    CONSUMO_PLANEJADO_PLA
    (V_CDFILIAL,
    V_CDSERVFILI,
    V_DTMESCARD,
    LAST_DAY(V_DTMESCARD),
    'C',
    'XFP',
    'N',
    0,
    'N',
    V_NRCONSPLAN,
    '0',
    'zzzzzzzzzz',
    P_CDOPERADOR);
    SELECT SUM(QTCONSPLAN *
    CUSTO_PRODUTO(C.CDFILICPLA, C.CDPRODCPLA,P_CDTIPOCUSTO,
    P_DTREFERENCIA, SYSDATE))
    INTO V_CUSTO_CONSUMO
    FROM CONSPLAN C
    WHERE C.NRCONSPLAN = V_NRCONSPLAN;
    
    V_CUSTO := V_CUSTO + NVL(V_CUSTO_CONSUMO, 0);
    V_CUSTO_ALT := V_CUSTO_ALT + NVL(V_CUSTO_CONSUMO, 0);

    P_PERCAPITA_OLD := 0;
    IF (V_COMENSAIS > 0) THEN
        P_PERCAPITA_OLD := V_CUSTO / V_COMENSAIS;
    END IF;
    P_PERCAPITA_NEW := 0;
    IF (V_COMENSAIS_ALT > 0) THEN
        P_PERCAPITA_NEW := V_CUSTO_ALT / V_COMENSAIS_ALT;
    END IF;
END;
/