var SignIn = function (localStorageEngine, LoginRepository, ConsultaJaLogado, PadraoExibicao, ValidaSenha, Criptography) {

	this.auth = function(fornecedor, email, senha) {

		return LoginRepository.autenticar(fornecedor, email, senha).then(function(sessao) {

			localStorageEngine.setLocalVar('CDFORNECED', sessao.fornecedor.CDFORNECED);
			localStorageEngine.setLocalVar('DSLOGINECO', sessao.fornecedor.DSLOGINECO);
			localStorageEngine.setLocalVar('IDACESSOCOT', sessao.fornecedor.IDACESSOCOT);
			localStorageEngine.setLocalVar('IDACESSOAF', sessao.fornecedor.IDACESSOAF);
			localStorageEngine.setLocalVar('IDACESSOCR', sessao.fornecedor.IDACESSOCR);
			localStorageEngine.setLocalVar('IDACESSOUPLOAD', sessao.fornecedor.IDACESSOUPLOAD);
			localStorageEngine.setLocalVar('IDADMINISTRADOR', sessao.fornecedor.IDADMINISTRADOR);
			localStorageEngine.setLocalVar('NMFANTFORN', sessao.fornecedor.NMFANTFORN);
			localStorageEngine.setLocalVar('NMRAZSOCFORN', sessao.fornecedor.NMRAZSOCFORN);
			localStorageEngine.setLocalVar('NRINSJURFORN', PadraoExibicao.mascaraFornecedor(sessao.fornecedor.IDTPIJURFORN, sessao.fornecedor.NRINSJURFORN));
			localStorageEngine.setLocalVar('IDTPIJURFORN', sessao.fornecedor.IDTPIJURFORN);
			localStorageEngine.setLocalVar('EMPRESACONTR', '08');
			localStorageEngine.setLocalVar('CDPICTPROD', sessao.paramgeral.CDPICTPROD.replace(/([^\.])/g, "A"));
			localStorageEngine.setLocalVar('IDSISDOS', sessao.paramgeral.IDSISDOS);
			localStorageEngine.setLocalVar('NRORG', sessao.paramgeral.NRORG);


		});

	};

	this.verifyAuth = function(email){

		return ConsultaJaLogado.verificaJaLogado(email);

	};

    this.validaSenha = function(cdsenhaweb, senha){

        return ValidaSenha.validaSenha(cdsenhaweb, senha);

    };

    this.criptographyPassword = function(password){

        return Criptography.criptographyPassword(password);

    };

};

Configuration(function(ContextRegister) {
	ContextRegister.register('SignIn', SignIn);
});